unit formMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.OleCtrls, WMPLib_TLB, Vcl.ExtCtrls,
  Vcl.ComCtrls;

type
  TfrmMain = class(TForm)
    WindowsMediaPlayer1: TWindowsMediaPlayer;
    ProgressBar1: TProgressBar;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure WindowsMediaPlayer1PlayStateChange(ASender: TObject;
      NewState: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
uses
  IOUtils
;

{$R *.dfm}

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  WindowsMediaPlayer1.controls.stop;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  WindowsMediaPlayer1.URL := 'file://' + TPath.Combine( ExtractFilePath( ParamStr( 0 ) ), 'BigBuckBunny.mp4' );
  WindowsMediaPlayer1.controls.play;
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  Duration: double;
  Position: double;
begin
  frmMain.Caption := WindowsMediaPlayer1.controls.currentPositionString
                   + ' of '
                   + WindowsMediaPlayer1.currentMedia.durationString;

  Duration := WindowsMediaPlayer1.currentMedia.duration;
  Position := WindowsMediaPlayer1.controls.currentPosition;
  ProgressBar1.Position := Trunc( Position*(Duration/ProgressBar1.Max) );
end;

procedure TfrmMain.WindowsMediaPlayer1PlayStateChange(ASender: TObject; NewState: Integer);
begin
  case NewState of
    wmppsPlaying: begin
      Timer1.Enabled := True;
    end;
    wmppsStopped,
    wmppsPaused: begin
      Timer1.Enabled := False;
    end;
  end;
end;

end.
